Foreman - Feature #22493

Add new logging options to integrate with logging-journald gem
02/02/2018 12:02 PM - Lukas Zapletal

Status: Closed
Priority: Normal
Assignee: Lukas Zapletal
Category: Logging
Target version: 1.18.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/5237,
https://github.com/theforeman/foreman/p
ull/5339,
https://github.com/theforeman/puppet-for
eman/pull/631,
https://github.com/theforeman/foreman/p
ull/5421
Description

Foreman uses logging gem for all logging, this has new plugin which enables structured logging into system journal (
https://github.com/Izap/logging-journald). This feature will add configuration options to use the logging plugin.

Foreman already uses MDC (mapped diagnostic context) for session/request id. As part of this effort, we will add more MDC flags

which are logged as structured fields in journald:

® logger name

¢ user login

¢ organization label

e |ocation label

e request id

e session id (safe only)
e remote ip address

As part of this, logging-journald will become hard dependency of foreman-core. Nothing is changing for development logging
configuration, but for production we will make changes in the installer to send logs into journald and splitting them via rsyslog back
into production.log for easier transition for existing users and tools. To be able to do that, all logs will be sent to facility local6

(configurable option).
Further reading:
e https://github.com/TwP/logging

e https:/github.com/sandfoxme/journald-logger
e https://github.com/Izap/logging-journald

Related issues:
Related to Installer - Feature #22559: Configure foreman to log to system jou...
Related to Foreman - Tracker #22569: Unified and structured logging

Related to Foreman - Feature #3861: Better logging/reporting/audit of provisi...

Related to Foreman - Bug #26039: Templates are getting rendered in production...
Associated revisions

Revision abbe2a04 - 03/13/2018 09:50 PM - Lukas Zapletal
Fixes #22493 - structured logging support

Revision ¢8202472 - 03/29/2018 08:46 AM - Lukas Zapletal
Refs #22493 - documented logging macros
https://github.com/lzap/logging-journald
https://github.com/TwP/logging
https://github.com/sandfoxme/journald-logger
https://github.com/lzap/logging-journald

[skip ci]

History

#1 - 02/06/2018 08:39 AM - Lukas Zapletal

- Description updated

#2 - 02/06/2018 12:29 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/5237 added

#3 - 02/12/2018 03:18 PM - Lukas Zapletal

- Related to Feature #22559: Configure foreman to log to system journal added

#4 - 02/13/2018 09:45 AM - Lukas Zapletal
- Related to Tracker #22569: Unified and structured logging added

#5 - 03/14/2018 06:37 AM - Lukas Zapletal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset abbe2a0494aa500c632702b9abeal1357e7{573aa.

#6 - 03/14/2018 07:00 AM - Marek Hulan

- translation missing: en.field_release set to 330

#7 - 03/20/2018 01:58 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/5339 added

#8 - 03/27/2018 10:38 AM - The Foreman Bot
- Pull request https://github.com/theforeman/puppet-foreman/pull/631 added

#9 - 04/09/2018 11:16 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/5421 added

#10 - 05/25/2018 07:57 AM - Lukas Zapletal
- Related to Feature #3861: Better logging/reporting/audit of provisioning including contents added

#11 - 02/14/2019 10:09 AM - Tomer Brisker
- Related to Bug #26039: Templates are getting rendered in production.log added
